class PcButton extends React.Component
{
  static get test() {return "test"}

  constructor(props)
  {
    super(props);

    this.state =
      {
        width:props.width,
        padHorizontal:32,
        padVertical:16,
        label:props.label,
        nextArrow:props.nextArrow,
        prevArrow:props.prevArrow
      }

    this.mute_sound = false;
    this.buttonBackground = React.createRef();
    this.buttonContainer = React.createRef();
  }

  static predictSize(label)
  {
    var e = document.createElement("canvas");
    var ctx = e.getContext("2d");
    ctx.font = PcConfig.scenario.fontSize + " " + PcConfig.scenario.fontFamily;
    var t= ctx.measureText(label);
    return t.width;
  }

  muteSound(yesno) 
  {
    PcConfig.dbg(CRASHDBG, "entering with yesno", yesno);
    this.mute_sound = yesno;
    PcConfig.dbg(CRASHDBG, "exiting");
  }
  getWidth()
  {
    return this.buttonBackground.current.getBoundingClientRect().width;
  }

  setWidth(w)
  {
    this.setState({width: w-(2*this.state.padHorizontal*PcConfig.renderSize)-2*PcConfig.scenario.buttonsBorderWidth});
  }

  updateLabel(label, prevArrow=null, nextArrow=null)
  {
    let prevArrowState, nextArrowState;
    prevArrowState = (prevArrow!=null) ?  prevArrow : this.state.prevArrow;
    nextArrowState = (nextArrow!=null) ?  nextArrow : this.state.nextArrow;
    this.setState({label:label, prevArrow:prevArrowState, nextArrow:nextArrowState});
  }

  onClick(e)
  {
    if (e.type === 'touchend')
    {
      //e.stopPropagation();
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    if (this.props.sound && !this.mute_sound) {
       this.props.sound.play();
     }
    if (this.props.onClick) this.props.onClick(); // calls PcScreeninfos:clickNext (->further calls validate()), required
  }

  render()
  {
    var borderColor = this.props.borderColor;
    var backgroundColor = this.props.backgroundColor;
    var textColor = this.props.fontColor;

    if (PcConfig.scenario.buttonsStyle=="rounded")
    {
      var borderRadius = 12 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="roundedMore")
    {
      var borderRadius = 36 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="square")
    {
      var borderRadius = 0;
    }

    let contentPadding = this.state.label!="" ? "&nbsp;" : "";
    let leftContent = this.state.prevArrow ? "&#9668;&nbsp;" + contentPadding : "";
    let rightContent = this.state.nextArrow ? contentPadding + "&nbsp;&#9658;" : "";
    let content = this.state.label!="" ? "&nbsp;" + this.state.label + "&nbsp;" : "";

    return e('div',
        {
          className:"pcbuttoncontainer",
          ref:this.buttonContainer,
          style:
          {
            opacity: 0,
            animation: PcConfig.scenario.elementsAnimationStyle,
            animationDelay:this.props.showDelay,
            left: this.props.x,
            top:this.props.y,
            marginLeft: this.props.spacingH,
            marginRight: this.props.spacingH,
            marginTop: this.props.spacingV,
            marginBottom: this.props.spacingV,
            visibility: this.props.visibility ? this.props.visibility : "", // this visibility field is enough to show/hide the button, no need for visibility in pcbutton below
          }
        },
        e('div', {style:{animation:this.props.animated ? "btLoop 4s infinite":""}},
          e('div',
            {
              className:"pcbutton",
              ref:this.buttonBackground,
              style:
                {
                  position:"relative",
                  width:this.state.width,
                  height:this.props.height,
                  borderStyle:"solid",
                  borderWidth:PcConfig.scenario.buttonsBorderWidth,
                  borderColor:borderColor,
                  backgroundColor:backgroundColor,
                  borderRadius:borderRadius,
                  paddingTop:this.state.padVertical*PcConfig.renderSize*(this.props.start?1.7:1),
                  paddingBottom:this.state.padVertical*PcConfig.renderSize*(this.props.start?1.7:1),
                  paddingLeft:this.state.padHorizontal*PcConfig.renderSize*(this.props.start?1.7:1),
                  paddingRight:this.state.padHorizontal*PcConfig.renderSize*(this.props.start?1.7:1),
                  overflow:"auto",
                  fontFamily:PcConfig.scenario.fontFamily,
                  fontSize:this.props.start ? PcConfig.scenario.fontSizeBig : PcConfig.scenario.fontSize,
                  color:textColor,
                  verticalAlign: "middle",
                  textAlign: "center",
                },
                onClick:(e)=>{this.onClick(e)},
                onTouchEnd:(e)=>{this.onClick(e)},
            },
            e('div', {style:{float:"left"}, dangerouslySetInnerHTML:{__html:leftContent}}),
            e('div', {style:{display:"inline-block"}, dangerouslySetInnerHTML:{__html:content}}), // this is where the button label goes
            e('div', {style:{float:"right"}, dangerouslySetInnerHTML:{__html:rightContent}})
          )
        )
    );
  }
}
