class PcKeyboard extends React.Component
{
  constructor(props)
  {
    super(props);
    this.keyboard = React.createRef();
    this.kind = props.kind;
    this.uppercase = props.uppercase;
  }

  componentWillReceiveProps(nextProps)
  {
    this.kind = nextProps.kind;
    this.uppercase = nextProps.uppercase;
    this.forceUpdate();
  }

  onClickKey(key)
  {
    if (key=="⇧")
    {
      this.kind=="text" ? this.kind="textmaj" : this.kind="text";
      this.forceUpdate();
      return;
    }
    else {
      if (this.kind=="textmaj")
      {
        this.kind="text";
        this.forceUpdate();
      }
    }

    if (key=="PAD") key = "";
    if (key=="&nbsp;") key = " ";

    this.props.onKeyPressed(key);
  }

  show()
  {
    this.keyboard.current.style.display="none";
    setTimeout(()=>this.keyboard.current.style.display="inline-flex", 100);
  }

  hide()
  {
    this.keyboard.current.style.display="none";
  }

  render()
  {
    let akeys = null;

    if (this.kind =="email")
    {
      akeys = [
        "@", PcConfig.keyboard.domain1, PcConfig.keyboard.domain2, ".com", ".fr", "⌫", "br",
        "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "br",
        "a", "z", "e", "r", "t", "y", "u", "i", "o", "p", "br",
        "q", "s", "d", "f", "g", "h", "j", "k", "l", "m", "br",
        "w", "x", "c", "v", "b", "n", ".", "-", "_", "←", "→"
      ]
    }

    if (this.kind =="text" && !this.uppercase)
    {
      akeys = [
        "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "⌫", "br",
        "a", "z", "e", "r", "t", "y", "u", "i", "o", "p", "br",
        "q", "s", "d", "f", "g", "h", "j", "k", "l", "m", "br",
        "w", "x", "c", "v", "b", "n", ".", "-", "'", "←", "→", "br",
        "⇧", "SPACE", ":", "_", "@", "?", "!", "\""
      ]
    }

    if (this.kind =="text" && this.uppercase)
    {
      akeys = [
        "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "⌫", "br",
        "A", "Z", "E", "R", "T", "Y", "U", "I", "O", "P", "br",
        "Q", "S", "D", "F", "G", "H", "J", "K", "L", "M", "br",
        "W", "X", "C", "V", "B", "N", ".", "-", "'", "←", "→", "br",
        "PAD", "SPACE", ":", "_", "@", "?", "!", "\""
      ]
    }

    if (this.kind =="textmaj")
    {
      akeys = [
        "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "⌫", "br",
        "A", "Z", "E", "R", "T", "Y", "U", "I", "O", "P", "br",
        "Q", "S", "D", "F", "G", "H", "J", "K", "L", "M", "br",
        "W", "X", "C", "V", "B", "N", ".", "-", "'", "←", "→", "br",
        "⇧", "SPACE", ":", "_", "@", "?", "!", "\""
      ]
    }

    if (this.kind =="textalt")
    {
      akeys = [
        "@", PcConfig.keyboard.domain1, PcConfig.keyboard.domain2, ".com", ".fr", "⌫", "br",
        "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "br",
        "a", "z", "e", "r", "t", "y", "u", "i", "o", "p", "br",
        "q", "s", "d", "f", "g", "h", "j", "k", "l", "m", "br",
        "w", "x", "c", "v", "b", "n", ".", "-", "_", "←", "→"
      ]
    }


    if (this.kind =="number")
    {
      akeys = [
        "PAD", "PAD", "7", "8", "9", "PAD", "PAD", "br",
        "PAD", "PAD", "4", "5", "6", "PAD", "PAD", "br",
        "PAD", "PAD", "1", "2", "3", "PAD", "PAD", "br",
        "PAD", "PAD", "0", "⌫", "PAD", "PAD", "br"
      ]
    }


    const keys = akeys.map((item,index) => {

      let grow = 1;
      let key = item + "_" + index;

      if (item=="SPACE") {grow=8; item="&nbsp;"}

      if (item!="br" && item!="PAD" && item!="⇧")
      {
        return e(PcKey,
          {
              key:key,
              label:item,
              grow:grow,
              spacingH:5*PcConfig.renderSize,
              spacingV:5*PcConfig.renderSize,
              color:this.props.color,
              backgroundColor:this.props.backgroundColor,
              onClick:()=>this.onClickKey(item)
          }
        )
      }
      else if (item =="PAD")
      {
        return e(PcKey,
          {
              key:key,
              label:"",
              grow:grow,
              spacingH:5*PcConfig.renderSize,
              spacingV:5*PcConfig.renderSize,
              color:this.props.color,
              backgroundColor:"rgba(255, 0, 0, 0)",
              onClick:()=>this.onClickKey(item)
          }
        )
      }
      else if (item =="br")
      {
          return e("div",
          {
            key:key,
            style:
            {
                width:"100%",
            }
          }
        );
      }
      else if (item == "⇧")
      {
        let c1 = this.props.color;
        let c2 = this.props.backgroundColor;

        if (this.kind=="textmaj")
        {
          c1 = this.props.backgroundColor;
          c2 = this.props.color;
        }

        return e(PcKey,
          {
              key:key,
              label:item,
              grow:grow,
              spacingH:5*PcConfig.renderSize,
              spacingV:5*PcConfig.renderSize,
              color:c1,
              backgroundColor:c2,
              onClick:()=>this.onClickKey(item)
          }
        )
      }
    });

    return e("div",
      {
        className:"pckeyboard",
        ref:this.keyboard,
        style:
        {
          position:"absolute",
          left:this.props.x,
          top:this.props.y,
          width:this.props.width,
          height:this.props.height,
          display:"inline-flex",
          justifyContent: "center",
          flexWrap: "wrap",
          alignContent:"center",
          animation:PcConfig.scenario.elementsAnimationStyle,
          animationDelay:this.props.showDelay,
        }
      },
      keys
    );
  }

}
