class PcLanguages extends React.Component
{
  constructor(props)
  {
    super(props);
    this.opened = false;

    this.mainDiv = React.createRef();
  }

  onClickMainLanguage(e)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    this.opened = !this.opened
    this.forceUpdate();

    if (this.opened)
    {
      this.mainDiv.current.style.transition="";
      this.mainDiv.current.style.opacity=0.5;
      this.mainDiv.current.style.transform="translateY(-5px)";

      setTimeout(()=>{
        this.mainDiv.current.style.transition="all 0.2s ease-out";
        this.mainDiv.current.style.opacity=1;
        this.mainDiv.current.style.transform="translateY(0px)";
      }, 10);
    }
  }

  onClickLanguage(l)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    this.props.changeLanguage(l);
  }

  onBlur()
  {
    if (this.opened) this.onClickMainLanguage();
  }


  render()
  {
    if (!this.props.visible) return null;

    if (PcConfig.scenario.buttonsStyle=="rounded")
    {
      var borderRadius = 12 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="roundedMore")
    {
      var borderRadius = 36 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="square")
    {
      var borderRadius = 0;
    }

    let iconSize = (PcConfig.renderSize*30)+"px";
    let iconUrl = PcConfig.host + "/ressources/icon_languages.png";
    let icon = "<div style='display:inline-block; width:"+iconSize+"; height:"+iconSize+"; background-color:"+PcConfig.scenario.langButtonTextColor+"; -webkit-mask-image:url("+iconUrl+"); -webkit-mask-size:"+iconSize+" "+iconSize+";'></div>";

    let mainTitle = "<div style='display:flex; align-items:center; justify-content:flex-end'>" + icon + " <div>&nbsp;"+PcConfig.scenario.languages[PcConfig.currentLanguage].symbol+"</div></div>";

    let languages = [];

    if (this.opened)
    {
      for (let i=0; i<PcConfig.scenario.languages.length; i++)
      {
          languages[i] = e('div',
            {
              key:"language"+i,
              onClick:(e)=>{this.onClickLanguage(i)},
              onTouchEnd:(e)=>{this.onClickLanguage(i)},
              style:{
                paddingTop:PcConfig.renderSize*15,
                margin:PcConfig.renderSize*10,
              },
              dangerouslySetInnerHTML:{__html:PcConfig.scenario.languages[i].label}
            }
          );
      }
    }

    return e('div',
      {
        ref:this.mainDiv,
        className:"pclanguagescontainer",
        onBlur:()=>{this.onBlur()},
        onClick:(e)=>{this.onClickMainLanguage(e)},
        onTouchEnd:(e)=>{this.onClickMainLanguage(e)},
        tabIndex:0,
        style:{
          position:"absolute",
          backgroundColor:PcConfig.scenario.langButtonBackgroundColor,
          fontFamily:PcConfig.scenario.fontFamily,
          fontSize:PcConfig.scenario.fontSizeMedium,
          color:PcConfig.scenario.langButtonTextColor,
          borderStyle:"solid",
          borderWidth:PcConfig.scenario.buttonsBorderWidth/4,
          borderColor:PcConfig.scenario.langButtonBorderColor,
          borderRadius:borderRadius,
          padding:PcConfig.renderSize*10,
          right:PcConfig.renderSize*20,
          top:-PcConfig.renderSize*10,
          textAlign:"right",
          outline:"none",
        },
      },
      e('div',
        {
          style:{
              margin:PcConfig.renderSize*10,
          },
          dangerouslySetInnerHTML:{__html:mainTitle}
        }
      ),
      languages
    );
  }
}
